<h2>Vote and Reward Settings</h2>
<?php
function saveChanges() {
	global $_POST;
	foreach($_POST as $setting) {
		if(!check_value($setting)) {
			message('error','Missing data (complete all fields).');
			return;
		}
	}
	$xmlPath = __PATH_MODULE_CONFIGS__.'usercp.vote.xml';
	$xml = simplexml_load_file($xmlPath);
	
	$xml->active = $_POST['setting_1'];
	$xml->vote_save_logs = $_POST['setting_2'];
	
	$save = $xml->asXML($xmlPath);
	if($save) {
		message('success','Settings successfully saved.');
	} else {
		message('error','There has been an error while saving changes.');
	}
}

function addVoteSite($title,$link,$reward,$time) {
	if(check_value($title) && check_value($link) && check_value($reward) && check_value($time)) {
		
		if($time < 1) {
			message('error','Waiting time must be at least 1 hour.');
			return;
		}
		
		$xmlPath = __PATH_MODULE_CONFIGS__.'usercp.vote.xml';
		$xml = simplexml_load_file($xmlPath);
		
		$vote_site = $xml->addChild('votesite');
		$vote_site->addChild('config', $title);
		$vote_site->addChild('config', $reward);
		$vote_site->addChild('config', $link);
		$vote_site->addChild('config', $link);
		$vote_site->addChild('config', $time);

		$save = $xml->asXML($xmlPath);
		
		if($save) {
			message('success','Voting site Successfully Added!');
		} else {
			message('error','There has been an error while adding the voting site.');
		}
		
	} else {
		message('error','Missing data (complete all fields).');
	}
}

function deleteVoteSite($id) {
	if(check_value($id)) {
		$xmlPath = __PATH_MODULE_CONFIGS__.'usercp.vote.xml';
		$xml = simplexml_load_file($xmlPath);
		
		$index = 0;
		foreach($xml->votesite as $site) {
			if($index == $id) {
				$dom = dom_import_simplexml($site);
				$remove = $dom->parentNode->removeChild($dom);
				if(!$remove) {
					message('error','There has been an error while deleting the voting site.');
					return;
				} else {
					$removed = true;
				}
			}
			$index++;
		}

		if($removed) {
			$save = $xml->asXML($xmlPath);
			if($save) {
				message('success','Voting Site Successfully Deleted!');
			} else {
				message('error','There has been an error while deleting the voting site.');
			}
		} else {
			message('error','No voting site found with the requested id.');
		}
		
		
	} else {
		message('error','Missing data (complete all fields).');
	}
}

if(check_value($_POST['submit_changes'])) {
	saveChanges();
}

if(check_value($_POST['votesite_add_submit'])) {
	addVoteSite($_POST['votesite_add_title'],$_POST['votesite_add_link'],$_POST['votesite_add_reward'],$_POST['votesite_add_time']);
}

if(check_value($_REQUEST['deletesite'])) {
	deleteVoteSite($_REQUEST['deletesite']);
}

loadModuleConfigs('usercp.vote');
?>
<form action="index.php?module=modules_manager&config=vote" method="post">
	<table class="table table-striped table-bordered table-hover module_config_tables">
		<tr>
			<th>Status<br/><span>Enable/disable the vote module.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_1',mconfig('active'),'Enabled','Disabled'); ?>
			</td>
		</tr>
		<tr>
			<th>Save Vote Logs<br/><span>If enabled, every vote will be permanently logged in a database table.</span></th>
			<td>
				<? enabledisableCheckboxes('setting_2',mconfig('vote_save_logs'),'Enabled','Disabled'); ?>
			</td>
		</tr>
		<tr>
			<td colspan="2"><input type="submit" name="submit_changes" value="Save Changes" class="btn btn-success"/></td>
		</tr>
	</table>
</form>

<hr>
<h3>Manage Vote Sites</h3>
<?php
if(array_key_exists('votesite', $mconfig)) {
	echo '<table class="table table-striped table-bordered table-hover module_config_tables">';
	echo '<tr>';
	echo '<th>Title</th>';
	echo '<th>Link (full url including http)</th>';
	echo '<th>Reward</th>';
	echo '<th>Vote Every</th>';
	echo '<th></th>';
	echo '</tr>';
	
	if(array_key_exists(0,$mconfig['votesite'])) {
		foreach($mconfig['votesite'] as $planKEY => $thisPLAN) {
			echo '<tr>';
			echo '<td>'.$thisPLAN['config'][0].'</td>';
			echo '<td>'.$thisPLAN['config'][2].'</td>';
			echo '<td>'.$thisPLAN['config'][1].' credit(s)</td>';
			echo '<td>'.$thisPLAN['config'][4].' hour(s)</td>';
			echo '<td><a href="index.php?module=modules_manager&config=vote&deletesite='.$planKEY.'" class="btn btn-block"><i class="icon-remove"></i></a></td>';
			echo '</tr>';
		}
	} else {
		echo '<tr>';
		echo '<td>'.$mconfig['votesite']['config'][0].'</td>';
		echo '<td>'.$mconfig['votesite']['config'][2].'</td>';
		echo '<td>'.$mconfig['votesite']['config'][1].' credit(s)</td>';
		echo '<td>'.$mconfig['votesite']['config'][4].' hour(s)</td>';
		echo '<td><a href="index.php?module=modules_manager&config=vote&deletesite=0" class="btn btn-block"><i class="icon-remove"></i></a></td>';
		echo '</tr>';
	}
	
	echo '<form action="index.php?module=modules_manager&config=vote" method="post">';
	echo '<tr>';
	echo '<td><input name="votesite_add_title" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_link" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_reward" class="input-mini" type="text"/> credit(s)</td>';
	echo '<td><input name="votesite_add_time" class="input-mini" type="text"/> hour(s)</td>';
	echo '<td><input type="submit" name="votesite_add_submit" class="btn btn-success" value="Add!"/></td>';
	echo '</tr>';
	echo '</form>';
	
	echo '</table>';
} else {
	echo '<h4>Add Voting Site</h4>';
	echo '<table class="table table-striped table-bordered table-hover module_config_tables">';
	echo '<tr>';
	echo '<th>Title</th>';
	echo '<th>Link (full url including http)</th>';
	echo '<th>Reward</th>';
	echo '<th>Vote Every</th>';
	echo '<th></th>';
	echo '</tr>';
	echo '<form action="index.php?module=modules_manager&config=vote" method="post">';
	echo '<tr>';
	echo '<td><input name="votesite_add_title" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_link" class="input-block-level" type="text"/></td>';
	echo '<td><input name="votesite_add_reward" class="input-mini" type="text"/> credit(s)</td>';
	echo '<td><input name="votesite_add_time" class="input-mini" type="text"/> hour(s)</td>';
	echo '<td><input type="submit" name="votesite_add_submit" class="btn btn-success" value="Add!"/></td>';
	echo '</tr>';
	echo '</form>';
	echo '</table>';
}

?>