<?php

class Vote {

	public function voteProcess($userid,$userip,$votesiteid) {
		global $common;
		if(check_value($userid) && check_value($userip) && check_value($votesiteid)) {
			//if(!Validator::Number($votesiteid)) { $error = true; }
			if(!Validator::Number($userid)) { $error = true; }
			if(!Validator::Ip($userip)) { $error = true; }
			if(!$error) {
				if($this->siteExists($votesiteid)) {
					if($this->canUserVote($userid,$votesiteid)) {
						if($this->canIPVote($userip,$votesiteid)) {
							
							// Add Record
							$add = $this->addRecord($userid,$userip,$votesiteid);
							
							if($add) {
								$voteSite = mconfig('votesite');
								if(array_key_exists(0,$voteSite)) {
									$voteLink = $voteSite[$votesiteid]['config'][2];
									$creditsReward = $voteSite[$votesiteid]['config'][1];
								} else {
									$voteLink = $voteSite['config'][2];
									$creditsReward = $voteSite['config'][1];
								}
								
								// Give Reward
								$reward = $common->addCredits($userid, $creditsReward);
								
								// Log Vote
								if(mconfig('vote_save_logs')) {
									$this->logVote($votesiteid,$userid);
								}
								
								// Redirect
								redirect(3, $voteLink);
								
							} else {
								// unknown error
								message('error', lang('error_23',true));
							}
							
						} else {
							// ip already voted
							message('error', lang('error_16',true));
						}
					} else {
						// user id already voted
						message('error', lang('error_15',true));
					}
				} else {
					// vote site doesnt exist
					message('error', lang('error_23',true));
				}
			} else {
				// unknown error
				message('error', lang('error_23',true));
			}
		} else {
			// unknown error
			message('error', lang('error_23',true));
		}
	}

	private function canUserVote($userid,$votesiteid) {
		global $dB;
		$check = $dB->query_fetch_single("SELECT * FROM "._TBL_VOTES_." WHERE user_id = '$userid' AND vote_site_id = '$votesiteid'");
		if(is_array($check)) {
			if($this->timePassed($check['timestamp'])) {
				$remove = $this->removeRecord($check['id']);
				if($remove) {
					return true;
				}
			}
		} else {
			return true;
		}
	}
	
	private function canIPVote($ip,$votesiteid) {
		global $dB;
		$check = $dB->query_fetch_single("SELECT * FROM "._TBL_VOTES_." WHERE user_ip = '$ip' AND vote_site_id = '$votesiteid'");
		if(is_array($check)) {
			if($this->timePassed($check['timestamp'])) {
				$remove = $this->removeRecord($check['id']);
				if($remove) {
					return true;
				}
			}
		} else {
			return true;
		}
	}
	
	private function addRecord($userid,$userip,$votesiteid) {
		global $dB,$common;
		if(is_array($common->accountInformation($userid))) {
			if($this->siteExists($votesiteid)) {
				$voteSiteInfo = mconfig('votesite');
				if(array_key_exists(0, $voteSiteInfo)) {
					$timestamp = time() + $voteSiteInfo[$votesiteid]['config'][4]*60*60;
				} else {
					$timestamp = time() + $voteSiteInfo['config'][4]*60*60;
				}
				$data = array(
					$userid,
					$userip,
					$votesiteid,
					$timestamp
				);
				$add = $dB->query("INSERT INTO "._TBL_VOTES_." (user_id, user_ip, vote_site_id, timestamp) VALUES (?, ?, ?, ?)", $data);
				
				if($add) {
					return true;
				}
			}
		}
	}
	
	function removeRecord($id) {
		global $dB;
		$dB->query("DELETE FROM "._TBL_VOTES_." WHERE id = '$id'");
		return true;
	}
	
	function timePassed($timestamp) {
		if(time() > $timestamp) {
			return true;
		}
	}
	
	function siteExists($id) {
		$vote_sites = mconfig('votesite');
		if(is_array($vote_sites)) {
			if(@array_key_exists(0, $vote_sites)) {
				if(is_array($vote_sites[$id]['config'])) {
					return true;
				}
			} else {
				if(is_array($vote_sites['config'])) {
					return true;
				}
			}
		}
	}
	
	function logVote($site_id,$user_id) {
		global $dB;
		$add_data = array(
			$user_id,
			$site_id,
			time()
		);
		$add_log = $dB->query("INSERT INTO "._TBL_VOTE_LOGS_." (user_id,votesite_id,timestamp) VALUES (?,?,?)", $add_data);
		if($add_log) {
			return true;
		}
	}

}

?>