<?php
/* --------------------------------------------------------------------

  WebEngine
  http://web.muengine.net/

  @version	1.0.4
  @author	Lautaro Anglico <http://lautaroangelico.com/>
			<angelico.lautaro@gmail.com>

  Copyright (C) 2012-2013 Lautaro Anglico All rights reserved.

  --------------------------------------------------------------------- */

/* Define time execution start */
define('__WEBENGINE_TIME_EXECUTION_STARTS__', microtime(true));

session_start();
ob_start();

/* Define current version */
define('__WEBENGINE_VERSION__', '1.0.4');
define('__WEBENGINE_ACP_VERSION__', '1.0.2');

/* Include the config file */
if(!@include_once(dirname(__FILE__).'/config.php')) die('[WEBENGINE::ERROR][!#] Could not load config.php');

/* Check if System is Active */
if(!$config['system_active']) {
	if(!in_array($_SESSION['username'],$config['admincp_users_access'])) {
		header('Location: '.$config['maintenance_page'].'');
		die();
	}
	$config['enable_session_timeout'] = false;
}

/* Define database connection constants */
define('__SQL_DB_HOST__',	$config['SQL_DB_HOST']);
define('__SQL_DB_NAME__',	$config['SQL_DB_NAME']);
define('__SQL_DB_2_NAME__',	$config['SQL_DB_2_NAME']);
define('__SQL_DB_USER__',	$config['SQL_DB_USER']);
define('__SQL_DB_PASS__',	$config['SQL_DB_PASS']);
define('__SQL_DB_PORT__',	$config['SQL_DB_PORT']);
define('__SQL_PDO_DRIVER__',$config['SQL_PDO_DRIVER']);

/* Define database tables */
define('_TBL_FLA_', 'WEBENGINE_FLA');
define('_TBL_VOTES_', 'WEBENGINE_VOTES');
define('_TBL_VOTE_LOGS_', 'WEBENGINE_VOTE_LOGS');
define('_TBL_NEWS_', 'WEBENGINE_NEWS');
define('_TBL_PAYPAL_', 'WEBENGINE_PAYPAL_TRANSACTIONS');
define('_TBL_SUPERREWARDS_', 'WEBENGINE_SR_TRANSACTIONS');
define('_TBL_SUPERREWARDS_ERRORS_', 'WEBENGINE_SR_ERROR_LOGS');
define('_TBL_CHANGEPASSWORD_REQUEST_', 'WEBENGINE_PASSCHANGE_REQUEST');
define('_TBL_PLUGINS_', 'WEBENGINE_PLUGINS');
define('_TBL_CRON_', 'WEBENGINE_CRON');
define('_TBL_DL_', 'WEBENGINE_DOWNLOADS');
define('_TBL_MI_', 'MEMB_INFO');
	define('_CLMN_USERNM_', 'memb___id');
	define('_CLMN_PASSWD_', 'memb__pwd');
	define('_CLMN_MEMBID_', 'memb_guid');
	define('_CLMN_EMAIL_', 'mail_addr');
	define('_CLMN_CREDITS_', 'cspoints');
	define('_CLMN_CREDITS_TEMP_', 'TempCredits');
	define('_CLMN_BLOCCODE_', 'bloc_code');
	define('_CLMN_VIP_STAMP_', 'VipStamp');
	define('_CLMN_MASTER_KEY_', 'MasterKey');
define('_TBL_MS_', 'MEMB_STAT');
	define('_CLMN_CONNSTAT_', 'ConnectStat');
	define('_CLMN_MS_MEMBID_', 'memb___id');
	define('_CLMN_MS_GS_', 'ServerName');
define('_TBL_AC_', 'AccountCharacter');
	define('_CLMN_AC_ID_', 'Id');
	define('_CLMN_GAMEID_1_', 'GameID1');
	define('_CLMN_GAMEID_2_', 'GameID2');
	define('_CLMN_GAMEID_3_', 'GameID3');
	define('_CLMN_GAMEID_4_', 'GameID4');
	define('_CLMN_GAMEID_5_', 'GameID5');
	define('_CLMN_GAMEIDC_', 'GameIDC');
define('_TBL_CHR_', 'Character');
	define('_CLMN_CHR_NAME_', 'Name');
	define('_CLMN_CHR_ACCID_', 'AccountID');
	define('_CLMN_CHR_CLASS_', 'Class');
	define('_CLMN_CHR_ZEN_', 'Money');
	define('_CLMN_CHR_LVL_', 'cLevel');
	define('_CLMN_CHR_RSTS_', 'Resets');
	define('_CLMN_CHR_LVLUP_POINT_', 'LevelUpPoint');
	define('_CLMN_CHR_STAT_STR_', 'Strength');
	define('_CLMN_CHR_STAT_AGI_', 'Dexterity');
	define('_CLMN_CHR_STAT_VIT_', 'Vitality');
	define('_CLMN_CHR_STAT_ENE_', 'Energy');
	define('_CLMN_CHR_STAT_CMD_', 'Leadership');
	define('_CLMN_CHR_PK_KILLS_', 'PkCount');
	define('_CLMN_CHR_PK_LEVEL_', 'PkLevel');
	define('_CLMN_CHR_PK_TIME_', 'PkTime');
	define('_CLMN_CHR_MAP_', 'MapNumber');
	define('_CLMN_CHR_MAP_X_', 'MapPosX');
	define('_CLMN_CHR_MAP_Y_', 'MapPosY');
	define('_CLMN_CHR_MAGIC_L_', 'MagicList');
	define('_CLMN_CHR_GRSTS_', 'Grand_Resets');
	define('_CLMN_CHR_PVPLS_WIN_', 'PvPLastStandWin');
define('_TBL_LOGEX_', 'MuLogEx');
	define('_CLMN_LOGEX_ACCID_', 'AccountId');
	define('_CLMN_LOGEX_IP_', 'IP');
	define('_CLMN_LOGEX_TIN_', 'TimeIn');
	define('_CLMN_LOGEX_TOUT_', 'TimeOut');
	define('_CLMN_LOGEX_OD_', 'OnlineDuration');
	define('_CLMN_LOGEX_SRV_', 'Server');
define('_TBL_MASTERLVL_', 'T_MasterLevelSystem');
	define('_CLMN_ML_NAME_', 'CHAR_NAME');
	define('_CLMN_ML_LVL_', 'MASTER_LEVEL');
	define('_CLMN_ML_EXP_', 'ML_EXP');
	define('_CLMN_ML_NEXP_', 'ML_NEXTEXP');
	define('_CLMN_ML_POINT_', 'ML_POINT');
define('_TBL_MC_', 'MEMB_CREDITS');
	define('_CLMN_MC_ID_', 'memb___id');
	define('_CLMN_MC_CREDITS_', 'Credits');
	define('_CLMN_MC_TEMPCREDITS_', 'TempCredits');
define('_TBL_REWARD_ITEM_', 'RewardItem');
define('_TBL_MUCASTLE_DATA_', 'MuCastle_DATA');
	define('_CLMN_MCD_GUILD_OWNER_', 'OWNER_GUILD');
define('_TBL_GUILD_', 'Guild');
	define('_CLMN_GUILD_NAME_', 'G_Name');
	define('_CLMN_GUILD_LOGO_', 'G_Mark');
	define('_CLMN_GUILD_SCORE_', 'G_Score');
	define('_CLMN_GUILD_MASTER_', 'G_Master');
	define('_CLMN_GUILD_NOTICE_', 'G_Notice');
	define('_CLMN_GUILD_UNION_', 'G_Union');

/* error reporting */
if($config['error_reporting']==false) {
	ini_set('display_errors', false);
	error_reporting(0);
} else {
	ini_set('display_errors', true);
	error_reporting(E_ALL & ~E_NOTICE);
}

/* encoding */
@ini_set('default_charset', 'utf-8');

/* CloudFlare IP workaround */
//$_SERVER['REMOTE_ADDR'] = (isset($_SERVER["HTTP_CF_CONNECTING_IP"])) ? $_SERVER["HTTP_CF_CONNECTING_IP"] : $_SERVER["REMOTE_ADDR"];

/* URL PATHS */
define('HTTP_HOST', $_SERVER['HTTP_HOST']);
define('SERVER_PROTOCOL', (!empty($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on' ) ? 'https://' : 'http://');
define('__ROOT_DIR__', str_replace('\\','/',dirname(dirname(__FILE__))).'/'); // /home/user/public_html/
define('__RELATIVE_ROOT__', str_ireplace(rtrim(str_replace('\\','/', realpath(str_replace($_SERVER['SCRIPT_NAME'], '', $_SERVER['SCRIPT_FILENAME']))), '/'), '', __ROOT_DIR__));// /
define('__BASE_URL__', SERVER_PROTOCOL.HTTP_HOST.__RELATIVE_ROOT__); // http(s)://www.mysite.com/

/* SYSTEM PATHS */
define('__PATH_INCLUDES__', __ROOT_DIR__.'includes/');
define('__PATH_TEMPLATES__', __ROOT_DIR__.'templates/');
define('__PATH_TEMPLATES_EXTRA__', __ROOT_DIR__.'templates/'.$config['website_template'].'/extra/');
define('__PATH_TEMPLATE__', __BASE_URL__ . 'templates/' . $config['website_template'] . '/');
//define('__PATH_TEMPLATE_IMG__', __BASE_URL__ . 'templates/' . $config['website_template'] . '/images/');
define('__PATH_TEMPLATE_IMG__', __BASE_URL__ . 'templates/' . $config['website_template'] . '/img/');
define('__PATH_LANGUAGES__', __ROOT_DIR__ . 'languages/');
define('__PATH_MAINTENANCE__', __ROOT_DIR__.'maintenance/');
define('__PATH_CLASSES__', __PATH_INCLUDES__.'classes/');
define('__PATH_FUNCTIONS__', __PATH_INCLUDES__.'functions/');
define('__PATH_MODULES__', __ROOT_DIR__.'modules/');
define('__PATH_MODULES_USERCP__', __PATH_MODULES__.'usercp/');
define('__PATH_MODULES_RANKINGS__', __BASE_URL__.'rankings/');
define('__PATH_EMAILS__', __PATH_INCLUDES__.'emails/');
define('__PATH_CACHE__', __PATH_INCLUDES__.'cache/');
define('__PATH_ADMINCP__', __ROOT_DIR__.'admincp/');
define('__PATH_ADMINCP_MODULES__', __ROOT_DIR__.'admincp/modules/');
define('__PATH_ADMINCP_HOME__', __BASE_URL__.'admincp/index.php');
define('__PATH_NEWS_CACHE__', __PATH_CACHE__.'news/');
define('__PATH_PLUGINS__', __PATH_INCLUDES__.'plugins/');
define('__PATH_CONFIGS__', __PATH_INCLUDES__.'config/');
define('__PATH_MODULE_CONFIGS__', __PATH_CONFIGS__.'modules/');
define('__PATH_CRON__', __ROOT_DIR__.'cron/');

/* MuEngine Bridge */
define("PROTO_GLOBAL_MESSAGE","A1");
define("PROTO_DISCONNECT","A3");
define("PROTO_BAN_DISCONNECT","A4");
define("PROTO_EMAIL_SEND","A5");
define("PROTO_BLSN_RELOAD","A6");

/* DEFINE CLASSES */
$webengine_classes = array(
	'class.database.php',
	'class.database2.php',
	'class.common.php',
	'class.handler.php',
	'class.validator.php',
	'class.login.php',
	'class.vote.php',
	'class.character.php',
	'class.encryption.php',
	'class.phpmailer.php',
	'class.smtp.php',
	'class.vip.php',
	'class.rankings.php',
	'class.news.php',
	'class.items.php',
	'class.muengine.php',
	'class.plugins.php'
);

/* DEFINE FUNCTIONS */
$webengine_functions = array(
	'function.global.php',
	'function.email.php',
	'function.recaptchalib.php',
	'function.config.php'
);

/* LOAD CLASSES AND FUNCTIONS */
foreach($webengine_classes as $loadClass) {
	if(!@include_once(__PATH_CLASSES__.$loadClass)) die('[WEBENGINE::ERROR][!#] Could not load '.$loadClass.'');
}
foreach($webengine_functions as $loadFunction) {
	if(!@include_once(__PATH_FUNCTIONS__.$loadFunction)) die('[WEBENGINE::ERROR][!#] Could not load '.$loadFunction.'');
}

// LOAD MEMCACHED
//$memcache = new Memcached();
//$memcache->connect('127.0.0.1', 11211) or die ("Could not connect");

// LOAD DATABASE CONNECTION ::
$dB = new dB();
$common = new common();

// LOAD SECOND DATABASE CONNECTION ::
if($config['SQL_USE_2_DB']) {
	$dB2 = new dB2();
}

// LOAD CUSTOM DATA
if(!@include_once(__PATH_INCLUDES__.'custom.php')) die('[WEBENGINE::ERROR][!#] Could not load custom.php');

// LOAD PLUGINS
if($config['plugins_system_enable']) {
	$PluginsSys = new Plugins();
	if($PluginsSys->gotEnabledPlugins()) {
		$PluginsSys->loadPlugins();
	}
}

// LOAD PAGE ::
$handler = new Handler();
$handler->loadPage();

/* Define time execution end */
define('__WEBENGINE_TIME_EXECUTION_ENDS__', microtime(true));

if(isset($_REQUEST['dev'])) {
	echo '<center>WebEngine '.__WEBENGINE_VERSION__.'<br />';
	echo 'Execution Time: '.(__WEBENGINE_TIME_EXECUTION_ENDS__-__WEBENGINE_TIME_EXECUTION_STARTS__).' seconds<br />';
	echo 'Memory Usage: '.memory_get_usage().' bytes<br />';
	echo 'Peak Memory Usage: '.memory_get_peak_usage().' bytes<br /><br /></center>';
}
?>